/*
 * JPA DAO Template
 *
 *
 * Takatuka - Template fuer JPA DAO
 *
 */

package de.ivu.elect.business.veranstaltung.boundary;

import javax.persistence.NoResultException;
import javax.persistence.NonUniqueResultException;
import javax.persistence.EntityNotFoundException;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import de.ivu.elect.business.veranstaltung.entity.Teilnahme;
import de.ivu.elect.business.veranstaltung.entity.TeilnahmeUK;

public abstract class AbstractTeilnahmeDAO extends de.ivu.elect.jee.entity.AbstractDAO<Teilnahme,
        de.ivu.elect.business.veranstaltung.entity.TeilnahmePK
    , TeilnahmeUK> {

  private static final long serialVersionUID = 1L;

  private static final Logger LOG = LoggerFactory.getLogger(AbstractTeilnahmeDAO.class);

  public AbstractTeilnahmeDAO() {
    super();
  }

  public boolean isEntityWithPKPresent(
            de.ivu.elect.business.veranstaltung.entity.TeilnahmePK
     pk) {
    if (pk != null && pk.getId() != null) {
      return findByPrimaryKey(pk) != null;
    }

    return false;
  }

  @Override
  public Teilnahme findByPrimaryKey(
        de.ivu.elect.business.veranstaltung.entity.TeilnahmePK
      pk) {
    if (pk != null && pk.getId() != null) {
      return findByPrimaryKey(pk.getId());
    }

    throw new IllegalArgumentException("PK oder PK.getId() ist null! [pk = " + pk + "]");
  }


  @Override
  protected Teilnahme findByPrimaryKey(Long id) {
    if (id == null) {
      throw new IllegalArgumentException("ID ist null! [id = " + id + "]");
    }
  return getEntityManager().find(Teilnahme.class, id, CACHE_PROPERTIES);
  }



     /**
      * Name: PersonAndWahlNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT o FROM Teilnahme o WHERE o.personendaten = ?1 AND o.veranstaltung.wahl = ?2<br>
      * SQL: <br>
      */
     public java.util.List<Teilnahme> findByPersonAndWahl( @javax.annotation.Nonnull de.ivu.elect.business.person.entity.Personendaten person,  @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

            try {

          		  			  de.ivu.elect.business.person.entity.Personendaten personCheckedAndAttached =  checkAndAttach(person, de.ivu.elect.business.person.entity.Personendaten.class, "person"); ;
		  			  de.ivu.elect.business.wahl.entity.Wahl wahlCheckedAndAttached =  checkAndAttach(wahl, de.ivu.elect.business.wahl.entity.Wahl.class, "wahl"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("TEILNAHME.PersonAndWahl")
                              .setParameter(1, personCheckedAndAttached)
                                        .setParameter(2, wahlCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (NonUniqueResultException nure) {
    LOG.warn("Teilnahme, findByPersonAndWahl - NonUniqueResultException, Parameter: "
           + ", person:'"+person+"'"
           + ", wahl:'"+wahl+"'"
    
        );
    throw nure;
        }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByPersonAndWahl(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: PersonAndWahlterminNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT o FROM Teilnahme o WHERE o.personendaten = ?1 AND o.veranstaltung.wahltermin = ?2<br>
      * SQL: <br>
      */
     public java.util.List<Teilnahme> findByPersonAndWahltermin( @javax.annotation.Nonnull de.ivu.elect.business.person.entity.Personendaten person,  @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahltermin wahltermin) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

            try {

          		  			  de.ivu.elect.business.person.entity.Personendaten personCheckedAndAttached =  checkAndAttach(person, de.ivu.elect.business.person.entity.Personendaten.class, "person"); ;
		  			  de.ivu.elect.business.wahl.entity.Wahltermin wahlterminCheckedAndAttached =  checkAndAttach(wahltermin, de.ivu.elect.business.wahl.entity.Wahltermin.class, "wahltermin"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("TEILNAHME.PersonAndWahltermin")
                              .setParameter(1, personCheckedAndAttached)
                                        .setParameter(2, wahlterminCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (NonUniqueResultException nure) {
    LOG.warn("Teilnahme, findByPersonAndWahltermin - NonUniqueResultException, Parameter: "
           + ", person:'"+person+"'"
           + ", wahltermin:'"+wahltermin+"'"
    
        );
    throw nure;
        }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByPersonAndWahltermin(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: PersonenNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT o FROM Teilnahme o WHERE o.personendaten IN ?1<br>
      * SQL: <br>
      */
     public java.util.List<Teilnahme> findByPersonen( @javax.annotation.Nonnull java.util.Collection<de.ivu.elect.business.person.entity.Personendaten> personendaten) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

            try {

          		  			  java.util.Collection<de.ivu.elect.business.person.entity.Personendaten> personendatenCheckedAndAttached =  personendaten ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("TEILNAHME.Personen")
                              .setParameter(1, personendatenCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (NonUniqueResultException nure) {
    LOG.warn("Teilnahme, findByPersonen - NonUniqueResultException, Parameter: "
           + ", personendaten:'"+personendaten+"'"
    
        );
    throw nure;
        }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByPersonen(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: VeranstaltungNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT o FROM Teilnahme o WHERE o.veranstaltung = ?1<br>
      * SQL: <br>
      */
     public java.util.List<Teilnahme> findByVeranstaltung( @javax.annotation.Nonnull de.ivu.elect.business.veranstaltung.entity.Veranstaltung veranstaltung) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

            try {

          		  			  de.ivu.elect.business.veranstaltung.entity.Veranstaltung veranstaltungCheckedAndAttached =  checkAndAttach(veranstaltung, de.ivu.elect.business.veranstaltung.entity.Veranstaltung.class, "veranstaltung"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("TEILNAHME.Veranstaltung")
                              .setParameter(1, veranstaltungCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (NonUniqueResultException nure) {
    LOG.warn("Teilnahme, findByVeranstaltung - NonUniqueResultException, Parameter: "
           + ", veranstaltung:'"+veranstaltung+"'"
    
        );
    throw nure;
        }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByVeranstaltung(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: WahlCountNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT COUNT(o) FROM Teilnahme o WHERE o.veranstaltung.wahl = ?1<br>
      * SQL: <br>
      */
     public java.lang.Long findByWahlCount( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

            try {

          		  			  de.ivu.elect.business.wahl.entity.Wahl wahlCheckedAndAttached =  checkAndAttach(wahl, de.ivu.elect.business.wahl.entity.Wahl.class, "wahl"); ;
		  
                              return
                    (java.lang.Long)
                              getEntityManager().
                                createNamedQuery("TEILNAHME.WahlCount")
                              .setParameter(1, wahlCheckedAndAttached)
                                                                      .getSingleResult();
                                        
                    
        } catch (NonUniqueResultException nure) {
    LOG.warn("Teilnahme, findByWahlCount - NonUniqueResultException, Parameter: "
           + ", wahl:'"+wahl+"'"
    
        );
    throw nure;
        }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByWahlCount(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: WahlNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT t FROM Teilnahme t WHERE t.veranstaltung.wahl=?1<br>
      * SQL: <br>
      */
     public java.util.List<Teilnahme> findByWahl( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

            try {

          		  			  de.ivu.elect.business.wahl.entity.Wahl wahlCheckedAndAttached =  checkAndAttach(wahl, de.ivu.elect.business.wahl.entity.Wahl.class, "wahl"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("TEILNAHME.Wahl")
                              .setParameter(1, wahlCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (NonUniqueResultException nure) {
    LOG.warn("Teilnahme, findByWahl - NonUniqueResultException, Parameter: "
           + ", wahl:'"+wahl+"'"
    
        );
    throw nure;
        }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByWahl(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: WahlterminCountNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT COUNT(o) FROM Teilnahme o WHERE o.veranstaltung.wahltermin = ?1<br>
      * SQL: <br>
      */
     public java.lang.Long findByWahlterminCount( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahltermin wahltermin) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

            try {

          		  			  de.ivu.elect.business.wahl.entity.Wahltermin wahlterminCheckedAndAttached =  checkAndAttach(wahltermin, de.ivu.elect.business.wahl.entity.Wahltermin.class, "wahltermin"); ;
		  
                              return
                    (java.lang.Long)
                              getEntityManager().
                                createNamedQuery("TEILNAHME.WahlterminCount")
                              .setParameter(1, wahlterminCheckedAndAttached)
                                                                      .getSingleResult();
                                        
                    
        } catch (NonUniqueResultException nure) {
    LOG.warn("Teilnahme, findByWahlterminCount - NonUniqueResultException, Parameter: "
           + ", wahltermin:'"+wahltermin+"'"
    
        );
    throw nure;
        }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByWahlterminCount(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: WahlterminNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT t FROM Teilnahme t WHERE t.veranstaltung.wahltermin=?1<br>
      * SQL: <br>
      */
     public java.util.List<Teilnahme> findByWahltermin( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahltermin wahltermin) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

            try {

          		  			  de.ivu.elect.business.wahl.entity.Wahltermin wahlterminCheckedAndAttached =  checkAndAttach(wahltermin, de.ivu.elect.business.wahl.entity.Wahltermin.class, "wahltermin"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("TEILNAHME.Wahltermin")
                              .setParameter(1, wahlterminCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (NonUniqueResultException nure) {
    LOG.warn("Teilnahme, findByWahltermin - NonUniqueResultException, Parameter: "
           + ", wahltermin:'"+wahltermin+"'"
    
        );
    throw nure;
        }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByWahltermin(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }



  @Override
  public boolean isEntityWithUKPresent(de.ivu.elect.business.veranstaltung.entity.TeilnahmeUK uk) {
    try {
      return findByUK(uk) != null;
    } catch (javax.persistence.NoResultException nre) {
      return false;
    }
  }

  @Override
  public boolean isEntityWithUKHasPK(de.ivu.elect.business.veranstaltung.entity.TeilnahmeUK uk,
        de.ivu.elect.business.veranstaltung.entity.TeilnahmePK
      pk

  ) {
    try {
      return findByUK(uk).getPk().equals(pk);
    } catch (NoResultException ignored) {
      // Do nothing - be happy.
    }
    return true;
  }

    public de.ivu.elect.business.veranstaltung.entity.Teilnahme findByUK(de.ivu.elect.business.veranstaltung.entity.TeilnahmeUK uk){
        throw new UnsupportedOperationException("Kein UK definiert");
    }


}